            #GIT_CMT=9b2436a570a1e309afce3414f0a9f322de20e3cd
%global debug_package %{nil}

#
# Example ARCHIVE Generation:
# export COMMIT=b6e48ec6
# export VERSION=1.1
# export RELEASE=1.el7
# rpmdev-setuptree
# git-archive-all --prefix edk2-${VERSION}/ ~/rpmbuild/SOURCES/edk2-${VERSION}-${RELEASE}.tar.gz
#
# Copy over patches/files:
# cp buildrpm/ol7/* ~/rpmbuild/SOURCES
#
# Build the RPMs:
# rpmbuild -ba buildrpm/ol7/edk2.spec
#
Name:		edk2
Version:	1.3.2
Release:    1.el7
Epoch:		1
Summary:	UEFI Firmware for 64-bit virtual machines

Group:		Applications/Emulators
License:	BSD and OpenSSL
URL:		http://www.tianocore.org
Source0: edk2-1.3.2.tar.bz2
Source1:	ovmf-vars-generator
Source2:	OpenSSL-1.1.D-c3656cc594daac8167721dde7220f0e59ae146fc.tgz

Patch4:		0001-MdeModulePkg-TerminalDxe-add-other-text-resolutions.patch
Patch5:		0001-EXCLUDE_SHELL_FROM_FD.patch

Patch10:	0001-OvmfPkg-SmbiosPlatformDxe-install-legacy-QEMU-tables.patch
Patch11:	0002-OvmfPkg-SmbiosPlatformDxe-install-patch-default-lega.patch
Patch12:	0003-OvmfPkg-SmbiosPlatformDxe-install-patch-default-lega.patch

Patch20:	0006-OvmfPkg-EnrollDefaultKeys-application-for-enrolling-.patch

Patch30:	0001-tools_def.template-take-GCC4-_-IA32-X64-prefixes-fro.patch
Patch31:  0002-tools_def.template-Take-parfait-prefix-from-the-envi.patch

Patch40:	0001-MdeModulePkg-silence-image-start-error.patch
Patch50:	0001-OvmfPkgX64-DSC-Updates.patch
Patch60:	0002-Smbios-ovmf-version-update.patch
Patch70:	0001-Bug31156337-Connect-MassStorage-WAR.patch
Patch80:	0001-Silence-BootOption-Load-Errors.patch

%bcond_with parfait

%ifarch x86_64
BuildRequires:	mtools
BuildRequires:	dosfstools
BuildRequires:	genisoimage
BuildRequires:	nasm
# For generating the variable store template with the
# default certificates enrolled, we need qemu.
BuildRequires:  qemu-system-x86-core
%endif
BuildRequires:	iasl
BuildRequires:	python
BuildRequires:	libuuid-devel
BuildRequires:	git


%description
EFI Development Kit II

%package tools
Summary:	EFI Development Kit II Tools
%description tools
EFI Development Kit II Tools


%ifarch x86_64
%global subpkgname OVMF

%package -n OVMF 
Summary:	UEFI Firmware for 64-bit virtual machines
License:	BSD and OpenSSL
BuildArch:      noarch

%description -n OVMF
UEFI Firmware for 64-bit virtual machines
%endif


%ifarch aarch64
%global subpkgname AAVMF

%package -n AAVMF 
Summary:	UEFI Firmware for aarch64 virtual machines
License:	BSD
BuildArch:      noarch

%description -n AAVMF 
UEFI Firmware for aarch64 virtual machines
%endif

%prep
%setup -q -n %{name}-%{version}

%patch4 -p1
%patch5 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch20 -p1
%patch30 -p1

%if 0%{?with_parfait}
%patch31 -p1
%endif

%patch40 -p1
%patch50 -p1
%patch60 -p1
%patch70 -p1
%patch80 -p1

cp -a -- %{SOURCE1} .
cp -a -- %{SOURCE2} .

tar xfz OpenSSL-1.1.D-c3656cc594daac8167721dde7220f0e59ae146fc.tgz -C CryptoPkg/Library/OpensslLib/

%build
source ./edksetup.sh

# figure tools switch
GCCVER=$(gcc --version | awk '{ print $3; exit}')
case "$GCCVER" in
4.4*)	CC_FLAGS="-t GCC44";;
4.5*)	CC_FLAGS="-t GCC45";;
4.6*)	CC_FLAGS="-t GCC46";;
4.7*)	CC_FLAGS="-t GCC47";;
4.8*)	CC_FLAGS="-t GCC48";;
4.9*)	CC_FLAGS="-t GCC49";;
5.*)	CC_FLAGS="-t GCC5";;
6.*)	CC_FLAGS="-t GCC5";;
7.*)	CC_FLAGS="-t GCC5";;
8.*)	CC_FLAGS="-t GCC5";;
9.*)	CC_FLAGS="-t GCC5";;
esac

# parallel builds
SMP_MFLAGS="%{?_smp_mflags}"
if [[ x"$SMP_MFLAGS" = x-j* ]]; then
	CC_FLAGS="$CC_FLAGS -n ${SMP_MFLAGS#-j}"
elif [ -n "%{?jobs}" ]; then
	CC_FLAGS="$CC_FLAGS -n %{?jobs}"
fi

%if 0%{?with_parfait}
# For running Parfait static analysis at the pre-build stage
export BUILD_CC=parfait-gcc
export BUILD_CXX=parfait-g++
export BUILD_AS=parfait-gcc
export BUILD_AR=parfait-ar
export BUILD_LD=parfait-ld
export LINKER=${BUILD_CC}
# For running Parfait static analysis on modules.
export PARFAIT_PREFIX=parfait-
%endif # with parfait

# prepare
make -C BaseTools

# build key encollment boot iso
build_iso()
{
	local ARCH="$1"
	local UEFI_BINDIR=$(
		echo -n Build/Ovmf${ARCH}/DEBUG_*/
		echo $ARCH | tr '[:lower:'] '[:upper:]'
	)
	local UEFI_SHELL_BINARY=$UEFI_BINDIR/Shell.efi
	local ENROLLER_BINARY=$UEFI_BINDIR/EnrollDefaultKeys.efi
	local UEFI_SHELL_IMAGE=uefi_shell_${ARCH}.img
	local ISO_IMAGE=OVMF/UefiShell.iso

	local UEFI_SHELL_BINARY_BNAME=$(basename -- "$UEFI_SHELL_BINARY")
	local UEFI_SHELL_SIZE=$(stat --format=%s -- "$UEFI_SHELL_BINARY")
	local ENROLLER_SIZE=$(stat --format=%s -- "$ENROLLER_BINARY")

	# add 1MB then 10% for metadata
	local UEFI_SHELL_IMAGE_KB=$((
		(UEFI_SHELL_SIZE + ENROLLER_SIZE +
		 1 * 1024 * 1024) * 11 / 10 / 1024
	))

	# create non-partitioned FAT image
	rm -f -- "$UEFI_SHELL_IMAGE"
	/usr/sbin/mkdosfs -C "$UEFI_SHELL_IMAGE" -n UEFI_SHELL -- "$UEFI_SHELL_IMAGE_KB"

	export MTOOLS_SKIP_CHECK=1
	mmd	-i "$UEFI_SHELL_IMAGE"				::efi
	mmd	-i "$UEFI_SHELL_IMAGE"				::efi/boot
	mcopy	-i "$UEFI_SHELL_IMAGE"	"$UEFI_SHELL_BINARY"	::efi/boot/bootx64.efi
	mcopy	-i "$UEFI_SHELL_IMAGE"	"$ENROLLER_BINARY"	::
	mdir	-i "$UEFI_SHELL_IMAGE"	-/			::

	# build ISO with FAT image file as El Torito EFI boot image
	genisoimage -input-charset ASCII -J -rational-rock \
		-efi-boot "$UEFI_SHELL_IMAGE" -no-emul-boot \
		-o "$ISO_IMAGE" -- "$UEFI_SHELL_IMAGE"
}

%ifarch x86_64
# build OVMF
for cfg in pure-efi pure-efi-debug secboot secboot-debug; do
	OVMF_FLAGS="$CC_FLAGS -D HTTP_BOOT_ENABLE -D FD_SIZE_4MB"

	case "$cfg" in
	pure-efi)
		# nothing
		;;
	pure-efi-debug)
		OVMF_FLAGS="$OVMF_FLAGS -D DEBUG_LOG_ENABLE"
		;;
	secboot)
		OVMF_FLAGS="$OVMF_FLAGS -D SECURE_BOOT_ENABLE"
		OVMF_FLAGS="$OVMF_FLAGS -D SMM_REQUIRE"
		OVMF_FLAGS="$OVMF_FLAGS -D TPM2_ENABLE"
		OVMF_FLAGS="$OVMF_FLAGS -D EXCLUDE_SHELL_FROM_FD"
		OVMF_FLAGS="$OVMF_FLAGS -D SB_OPROM_VERIFY"
		;;
	secboot-debug)
		OVMF_FLAGS="$OVMF_FLAGS -D DEBUG_LOG_ENABLE"
		OVMF_FLAGS="$OVMF_FLAGS -D SECURE_BOOT_ENABLE"
		OVMF_FLAGS="$OVMF_FLAGS -D SMM_REQUIRE"
		OVMF_FLAGS="$OVMF_FLAGS -D TPM2_ENABLE"
		OVMF_FLAGS="$OVMF_FLAGS -D EXCLUDE_SHELL_FROM_FD"
		OVMF_FLAGS="$OVMF_FLAGS -D SB_OPROM_VERIFY"
		;;
	esac

	build $OVMF_FLAGS -a X64 -p OvmfPkg/OvmfPkgX64.dsc
	mkdir -p "OVMF"
	cp Build/OvmfX64/DEBUG_*/FV/OVMF_CODE.fd OVMF/OVMF_CODE.${cfg}.fd
	cp Build/OvmfX64/DEBUG_*/FV/OVMF_VARS.fd OVMF/OVMF_VARS.${cfg}.fd
	if [ "$cfg" = secboot ] || [ "$cfg" = secboot-debug ] ; then
		build_iso X64
		# Enroll the default certificates in the variable store template.
		python ovmf-vars-generator --verbose --verbose \
		  --verbose --print-output \
		  --qemu-binary        /usr/bin/qemu-system-x86_64 \
		  --ovmf-binary        OVMF/OVMF_CODE.${cfg}.fd \
		  --ovmf-template-vars OVMF/OVMF_VARS.${cfg}.fd \
		  --uefi-shell-iso     OVMF/UefiShell.iso \
		  --skip-testing \
		  OVMF_VARS.${cfg}.fd

		mv -f OVMF_VARS.${cfg}.fd OVMF/OVMF_VARS.${cfg}.fd

		# For secboot we want an additional var file named 'OVMF_VARS'
		# to be consistent with default OVMF package.
		if [ "$cfg" = secboot ]; then
			cp OVMF/OVMF_VARS.${cfg}.fd OVMF/OVMF_VARS.fd
		fi
	fi

  %if 0%{?with_parfait}
  mv Build/OvmfX64 Build/OvmfX64-${cfg}
  %else
	rm -rf Build/OvmfX64
  %endif

done


%endif

%ifarch aarch64
# build AAVMF 
mkdir -p "AAVMF"
# first build "verbose" version - for extra DEBUG output.
build $CC_FLAGS -a AARCH64 \
    -D DEBUG_PRINT_ERROR_LEVEL=0x8040004F \
    -D HTTP_BOOT_ENABLE \
    -p ArmVirtPkg/ArmVirtQemu.dsc
cp Build/ArmVirtQemu-AARCH64/DEBUG_*/FV/QEMU_EFI.fd AAVMF/QEMU_EFI.verbose.fd

build $CC_FLAGS -a AARCH64 \
    -D DEBUG_PRINT_ERROR_LEVEL=0x80000000 \
    -D HTTP_BOOT_ENABLE \
    -p ArmVirtPkg/ArmVirtQemu.dsc
cp Build/ArmVirtQemu-AARCH64/DEBUG_*/FV/*.fd AAVMF
%endif

%if %{with parfait}

# URL to use for Parfait baseline
_parfait_server=%{?_parfait_server}%{!?_parfait_server:https://ca-qa-parfait.us.oracle.com:9991/parfait-server/projects/EDK2/tasks/v%{version}}

# number of jobs to run in parallel (default: value returned by nproc(1).)
_parfait_threads=%{?_parfait_threads}%{!?_parfait_threads:$(nproc)}

# Location to store graphical report (default: ./parfait_html in BUILD dir)
_parfait_output=%{?_parfait_output}%{!?_parfait_output:"./parfait_html"}

# Parfait defect options:
# The 'misaligned-access' check only affects performance for
# most processor architectures, and it is disabled by default
# (unless enabled by '-e all' like we do; so we reverse that).
# see http://parfait.us.oracle.com/latest/ParfaitMisalignedAccess.html
#
_parfait_defect_opts=" -e all -d misaligned-access"

# Select whether to compare against baseline (default) using '-b'
# or upload results (-s) if _parfait_upload is set to 1 on command-line
# (if _parfait_upload is set, the the source base dir is also set via -z)
_parfait_upload=%{?_parfait_upload:"-s"}%{!?_parfait_upload:"-b"}
_parfait_srcdir=%{?_parfait_upload:"-z %{_builddir}/%{name}-%{version}/"}

# By default the parfait tool only scans the linked *.bc files and ignore
# the obj bc files (e.g:  *.obj.bc). To have the parfait tool also cover
# the *.obj.bc files, store all *.bc to a text file and pass it to parfait
# using '-L'.
find . -name \*.bc > file_list
_parfait_file_list="-L file_list"

RC=0
parfait -j $_parfait_threads $_parfait_defect_opts -g $_parfait_output $_parfait_upload $_parfait_server $_parfait_srcdir $_parfait_file_list || RC=$?

# Remove temp directories
rm -rf file_list Build/OvmfX64-*

# Work is ongoing to triage all the issues reported by Parfait on the EDK2
# codebase but until they are all are either fixed or marked as a
# False Positive/Will-Not-Fix on the EDK2 Parfait server($_parfait_server),
# the parfait run will return 1 so we need to check the return value
# and ignore it if it's 1 or zero (success, in which case this check can be
# removed).
#
# For more details on exit codes, see the Parfait documentation:
# http://parfait.us.oracle.com/latest/ParfaitInfo.html#exit-codes
#
if [ ${RC} != 0 -a ${RC} != 1 ]; then
  exit ${RC}
fi

%endif # with parfait

%install

mkdir -p %{buildroot}%{_bindir}
install	--strip \
	BaseTools/Source/C/bin/EfiRom \
	BaseTools/Source/C/bin/VolInfo \
	%{buildroot}%{_bindir}

# Install License files
mkdir -p %{buildroot}/%{_docdir}/%{subpkgname}/Licenses
cp -a OvmfPkg/License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/OvmfPkg-License.txt
%ifarch x86_64
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/edk2-License.txt
cp -a CryptoPkg/Library/OpensslLib/openssl/LICENSE %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/OpensslLib-License.txt
%endif
%ifarch aarch64
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/FatPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/IntelFrameworkModulePkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/MdeModulePkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/MdePkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/OptionRomPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/ShellPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/ArmPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/ArmPlatformPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/EmbeddedPkg-License.txt
%endif

%ifarch x86_64
mkdir -p %{buildroot}/usr/share/%{subpkgname}
cp -a OVMF/* %{buildroot}/usr/share/%{subpkgname}
cp -a OvmfPkg/README %{buildroot}/%{_docdir}/%{subpkgname}
cp -a OVMF-ol7-changelog.txt %{buildroot}/%{_docdir}/%{subpkgname}
%endif
%ifarch aarch64
mkdir -p %{buildroot}/usr/share/%{subpkgname}
# Pad the binaries and name them similar to the standard AAVMF package
cat AAVMF/QEMU_EFI.verbose.fd /dev/zero | head -c 64m > %{buildroot}/usr/share/%{subpkgname}/AAVMF_CODE.verbose.fd
cat AAVMF/QEMU_EFI.fd /dev/zero | head -c 64m > %{buildroot}/usr/share/%{subpkgname}/AAVMF_CODE.fd
cat AAVMF/QEMU_VARS.fd /dev/zero | head -c 64m > %{buildroot}/usr/share/%{subpkgname}/AAVMF_VARS.fd
cp -a AAVMF-ol7-changelog.txt %{buildroot}/%{_docdir}/%{subpkgname}
%endif

%files tools
%doc BaseTools/UserManuals/EfiRom_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/VolInfo_Utility_Man_Page.rtf
%{_bindir}/*

%defattr(-,root,root,-)

%ifarch x86_64
%files -n OVMF 
%dir /usr/share/%{subpkgname}
/usr/share/%{subpkgname}
%endif

%ifarch aarch64
%files -n AAVMF
%dir /usr/share/%{subpkgname}
/usr/share/%{subpkgname}
%endif

%dir %{_docdir}/%{subpkgname}/Licenses
%doc %{_docdir}/%{subpkgname}/Licenses/OvmfPkg-License.txt

%ifarch x86_64
%doc %{_docdir}/%{subpkgname}/Licenses/OpensslLib-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/edk2-License.txt
%doc %{_docdir}/%{subpkgname}/README
%doc %{_docdir}/%{subpkgname}/OVMF-ol7-changelog.txt
%endif

%ifarch aarch64
%doc %{_docdir}/%{subpkgname}/Licenses/FatPkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/IntelFrameworkModulePkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/MdeModulePkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/MdePkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/OptionRomPkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/ArmPkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/ArmPlatformPkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/EmbeddedPkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/ShellPkg-License.txt
%doc %{_docdir}/%{subpkgname}/AAVMF-ol7-changelog.txt
%endif


%changelog
* Fri Jul 31 2020 Aaron Young <Aaron.Young@oracle.com> - 1:1.3.2-1.el7
- Updates for OVMF/AAVMF Version 1.3.2 including:

* Fri Jul 31 2020 Aaron Young <aaron.young@oracle.com>
- Create new 1.3.2 release for OL7
* Fri May 1 2020 Aaron Young <aaron.young@oracle.com>
- Create new 1.3.1 release for OL7
* Wed Feb 5 2020 Aaron Young <aaron.young@oracle.com>
- Create new 1.3 release for OL7 which includes the following fixed CVEs:
  {CVE-2018-12182} {CVE-2019-13224} {CVE-2019-13225} {CVE-2019-14553}
* Fri May 17 2019 Aaron Young <aaron.young@oracle.com>
- Create new 1.2 release for OL7 which includes the following fixed CVEs:
  {CVE-2017-5715} {CVE-2017-5731} {CVE-2017-5732} {CVE-2017-5733} {CVE-2017-5734} {CVE-2017-5735} {CVE-2017-5753} {CVE-2018-12178} {CVE-2018-12180} {CVE-2018-12181} {CVE-2018-3630}

